program limes;
uses graph,maus,crt,dos;
type transzeiger=^transtyp;
     atyp=array[1..2,1..2] of real;
     btyp=array[1..2] of real;
     transtyp=record
                a:atyp;
                b:btyp;
                zufall:byte;
                zurueck,weiter:transzeiger;
              end;
    koordtyp=array[1..4,1..2] of real;
    fractsavetyp=record
                   a:atyp;
                   b:btyp;
                   zufall:byte;
                 end;
    hilftranstyp=record
                   alttrans:transtyp;
                   aspektratio,relx,rely,zoom:real;
                 end;
const einheitsrechteck:koordtyp=((0,1),(1,1),(1,0),(0,0));
      alle=2;
      eine=1;
      keine=0;
      erstes=true;
      zweites=false;
      getrennt=false;
var graphdriver,graphmode:integer;
    mauscursor:pointer;
    mausbenutzt,mauspresent,maussicht_:boolean;
    altx,alty,xpos,ypos,tasten,maxx,maxy:word;
    trans,akttrans:transzeiger;
    hilftrans:hilftranstyp;
    relx,rely,lizoom,zoom,aspektratio:real;
    kombiniert:boolean;
    name:namestr;
    transanzahl,akttranszahl:byte;
    dummy,za,x,y,xh,yh:real;
    zufallgesamt:word;
    pfad:pathstr;
    rechteck:koordtyp;
    ein:char;
    oldexit:pointer;

{$L EGAVGA}
{$L HERCDRV}
{$L CGADRV}
procedure EGAVGAdriver;external;
procedure CGAdriver;external;
procedure Hercdriver;external;

procedure kreuz(aspektratio,relx,rely,zoom:real);
var za:real;
begin
  setviewport(0,0,maxx,maxy-30,true);
  setwritemode(xorput);
  za:=zoom*aspektratio;
  setcolor(lightblue);
  line(round((relx)*maxx*za),maxy-round((rely-1)*maxy*zoom),round((relx)*maxx*za),maxy-round((rely+1)*maxy*zoom));
  line(round((relx-1)*maxx*za),maxy-round((rely)*maxy*zoom),round((relx+1)*maxx*za),maxy-round((rely)*maxy*zoom));
  setviewport(0,0,maxx,maxy,true);
end;

procedure bewegezeiger;
begin
  if maussicht_ then begin
    putimage(altx-5,alty-5,mauscursor^,xorput);
    putimage(xpos-5,ypos-5,mauscursor^,xorput);
  end;
  altx:=xpos; alty:=ypos;
end;

procedure mausunsicht;
begin
  if maussicht_ then begin
    putimage(altx-5,alty-5,mauscursor^,xorput);
    maussicht_:=false;
  end;
end;

procedure maussicht;
begin
  if (not maussicht_) and mauspresent then begin
    putimage(xpos-5,ypos-5,mauscursor^,xorput);
    maussicht_:=true;
    altx:=xpos;alty:=ypos;
  end;
end;

function mausin(x,y,xe,ye:integer):boolean;
begin
  mausin := (xpos >= x) and (xpos <= xe) and (ypos >= y) and (ypos <= ye);
end;

procedure initmauscursor;
begin
  setcolor(white);
  line(5,0,5,10);
  line(0,5,10,5);
  getmem(mauscursor,imagesize(0,0,10,10));
  getimage(0,0,10,10,mauscursor^);
  bar(0,0,10,10);
end;

procedure initmaus;
begin
  maussicht_:=false;
  if graphdriver=hercmono then mem[$40:$49] := 6;
  mausinit(tasten);
  mauspresent:=tasten<>0;
  if mauspresent then begin
    maustastpos(tasten,xpos,ypos);
    maus.mausunsicht;
    mausminmaxx(5,maxx-5);
    mausminmaxy(5,maxy);
    maussetpos(maxx div 2,maxy div 2);
    maussicht;
  end;
end;

procedure showtrans(trans:transtyp;aspektratio,relx,rely,zoom:real;aktrechteck:koordtyp);
var koord:koordtyp;
    x:byte;
    xk,yk,xh,yh:integer;
    za:real;
    hilfrechteck:koordtyp;
begin
  setviewport(0,0,maxx,maxy-30,true);
  za:=zoom*aspektratio;
  setwritemode(xorput);
  if trans.zurueck=nil then hilfrechteck:=einheitsrechteck
  else hilfrechteck:=aktrechteck;
  for x:=1 to 5 do with trans do begin
    if x<5 then begin
      xk:=round((a[1,1]*hilfrechteck[x,1]+a[1,2]*hilfrechteck[x,2]+b[1]+relx)*maxx*za);
      yk:=maxy-round((a[2,1]*hilfrechteck[x,1]+a[2,2]*hilfrechteck[x,2]+b[2]+rely)*maxy*zoom);
    end;
    if x=1 then begin
      moveto(xk,yk);
      xh:=xk;
      yh:=yk;
    end else begin
      case x of
        2:setlinestyle(dottedln,0,normwidth);
        3:setlinestyle(dashedln,0,normwidth);
        4:setlinestyle(solidln,0,normwidth);
      end;
      if x=5 then lineto(xh,yh) else lineto(xk,yk);
    end;
  end;
  setviewport(0,0,maxx,maxy,true);
end;

procedure update_hilftrans;
begin
  hilftrans.alttrans:=akttrans^;
  hilftrans.zoom:=zoom;
  hilftrans.relx:=relx;
  hilftrans.rely:=rely;
  hilftrans.aspektratio:=aspektratio;
end;

procedure zeigetrans;
begin
  if transanzahl=0 then setcolor(white) else setcolor(yellow);
  with hilftrans do showtrans(alttrans,aspektratio,relx,rely,zoom,rechteck);
  showtrans(akttrans^,aspektratio,relx,rely,zoom,rechteck);
  update_hilftrans
end;

procedure zeigealletrans(a,b:koordtyp);
var htrans:transzeiger;
begin
  with hilftrans do kreuz(aspektratio,relx,rely,zoom);
  kreuz(aspektratio,relx,rely,zoom);
  htrans:=trans;
  while (htrans<>nil) do begin
    if htrans^.zurueck=nil then begin
      if htrans=akttrans then setcolor(white) else setcolor(lightblue);
    end else if htrans=akttrans then setcolor(yellow) else setcolor(green);
    with hilftrans do if htrans=akttrans then showtrans(alttrans,aspektratio,relx,rely,zoom,a)
    else showtrans(htrans^,aspektratio,relx,rely,zoom,a);
    showtrans(htrans^,aspektratio,relx,rely,zoom,b);
    htrans:=htrans^.zurueck;
  end;
  update_hilftrans;
end;

procedure zeiger(p:real;x:word);
var buffer:string[6];
begin
  setcolor(lightmagenta);
  str(p:6:3,buffer);
  bar(x,maxy-20,x+6*8,maxy-20+8);
  outtextxy(x,maxy-20,buffer);
end;

procedure zeigeb(p:byte;x,y:word);
var buffer:string[3];
begin
  setcolor(lightmagenta);
  str(p,buffer);
  bar(x,y,x+3*8,y+8);
  outtextxy(x,y,buffer);
end;

procedure getstring(var s:string;x,y:word;l:byte);
var s2:string;
begin
  while keypressed do ein:=readkey;
  mausunsicht;
  setcolor(white);
  bar(x,y,x+8*l,y+8);
  s2:='';
  repeat
    repeat until keypressed;
    while keypressed do ein:=upcase(readkey);
    if (ein>#32) then begin
      s2:=s2+ein;
      outtextxy(x+pred(length(s2))*8,y,ein);
    end;
  until (length(s2)=l) or (ein=#13) or (ein=#27);
  if (ein<>#27) then s:=s2 else begin
    bar(x,y,x+8*l,y+8);
    outtextxy(x,y,s);
  end;
  maussicht;
end;

procedure werteneu;
begin
  mausunsicht;
  setcolor(lightmagenta);
  with akttrans^ do begin
    zeiger(a[1,1],8); zeiger(a[2,2],8*8);
    zeiger(a[1,2],8*15); zeiger(a[2,1],8*22);
    zeiger(b[1],8*29); zeiger(b[2],8*36);
    zeigeb(zufall,8*73,maxy-20);
    if zufallgesamt<>0 then zeigeb(trunc(zufall/zufallgesamt*100),8*73,maxy-10) else
      zeigeb(0,8*73,maxy-10);
  end;
  zeiger(zoom,8*43);
  zeiger(lizoom,8*50);
  zeiger(relx,8*57);
  zeiger(rely,8*64);
  bar(8*46,maxy-10,8*54,maxy);
  outtextxy(8*46,maxy-10,name);
  zeigeb(akttranszahl,8*8,maxy-10);
  zeigeb(transanzahl,8*25,maxY-10);
  bar(8*21,maxy-10,8*22-1,maxy);
  if kombiniert then outtextxy(8*21,maxy-10,'&') else outtextxy(8*21,maxy-10,'|');
  maussicht;
end;

procedure maske;
begin
  mausunsicht;
  setcolor(lightgreen);
  outtextxy(8*2,maxy-30,'Breite Hhe   Pam-X  Pam-Y  X-Pos  Y-Pos  Zoom  LiZoom  Rel-X  Rel-Y  Zufall');
  outtextxy(8*2,maxy-10,'  <-     ->  ><  X Y       Save Load Name:         .FRA  Ende IFS         %');
  Werteneu;
  maussicht;
end;

procedure bildneu;
var htrans:transzeiger;
begin
  mausunsicht;
  clearviewport;
  kreuz(aspektratio,relx,rely,zoom);
  htrans:=trans;
  while (htrans<>nil) do begin
    mausunsicht;
    if htrans^.zurueck=nil then begin
      if htrans=akttrans then setcolor(white) else setcolor(lightblue);
    end else if htrans=akttrans then setcolor(yellow) else setcolor(green);
    showtrans(htrans^,aspektratio,relx,rely,zoom,rechteck);
    maussicht;
    htrans:=htrans^.zurueck;
  end;
  maske;
  update_hilftrans;
end;

procedure calc_new_point;
var x2:real;
    z:byte;
    htrans:transzeiger;
    aktzufall,zahlzufall:word;
begin
  aktzufall:=succ(random(zufallgesamt));
  zahlzufall:=0;
  htrans:=trans;
  inc(zahlzufall,htrans^.zufall);
  while (zahlzufall<aktzufall) do begin
    htrans:=htrans^.zurueck;
    inc(zahlzufall,htrans^.zufall);
  end;
  with htrans^ do begin
    x2:=a[1,1]*x+a[1,2]*y+b[1];
     y:=a[2,1]*x+a[2,2]*y+b[2];
     x:=x2;
  end;
end;

procedure grafikinit2;
var xasp,yasp:word;
begin
  maxx:=getmaxx;maxy:=getmaxy;
  if (graphdriver=cga) or (graphdriver=hercmono) then begin
    setfillstyle(solidfill,black);
    setbkcolor(black);
    setcolor(white);
  end else begin
    setbkcolor(blue);
    setcolor(yellow);
    setfillstyle(solidfill,blue);
  end;
  getaspectratio(xasp,yasp);
  aspektratio:=(yasp/xasp)*(maxy/maxx);
end;

procedure berechnerechteck; {darf nur mit akttrans->t0aufgerufen werden}
var x:byte;
begin
  for x:=1 to 4 do with akttrans^ do begin
    rechteck[x,1]:=(a[1,1]*einheitsrechteck[x,1]+a[1,2]*einheitsrechteck[x,2]+b[1]);
    rechteck[x,2]:=(a[2,1]*einheitsrechteck[x,1]+a[2,2]*einheitsrechteck[x,2]+b[2]);
  end;
end;

procedure zeigen(global:byte);
var altrechteck:koordtyp;
begin
  if global<>keine then
  if akttrans^.zurueck=nil then begin
    altrechteck:=rechteck;
    berechnerechteck;
    zeigealletrans(altrechteck,rechteck);
  end else if global=alle then zeigealletrans(rechteck,rechteck) else zeigetrans;
end;

procedure signal;
var z:byte;
begin
  for z:=0 to 255 do begin
    sound(z*8);
    delay(1);
  end;
  nosound;
end;

procedure zuruecksetzen;
begin
  signal;
  x:=random;
  y:=random;
  xh:=succ(maxx);
  yh:=succ(maxy);
end;

procedure getreal(var s1:real;x1:word;var s2:real;x2:word;global:byte;kombiniert,erstes:boolean);
var xalt,yalt:word;
    zahlen:boolean;
    z:byte;
    seite,grafikumgeschalten:boolean;
begin
  zahlen:=true;
  grafikumgeschalten:=false;
  maustastpos(tasten,xpos,ypos);
  xalt:=xpos;yalt:=ypos;
  mausunsicht;
  maussetpos(100,100);
  repeat
    repeat
      maustastpos(tasten,xpos,ypos);
    until (tasten=0) or (tasten>=3) or (xpos<>100) or (ypos<>100);
    maussetpos(100,100);
    if (tasten>=3) and (akttrans^.zurueck<>nil) then begin
      if zahlen then begin
        randomize;
        x:=random;
        y:=random;
        seite:=false;
        zahlen:=not zahlen;
        if graphdriver=vga then begin
          graphdriver:=ega;
          graphmode:=egahi;
          initgraph(graphdriver,graphmode,pfad);
          grafikinit2;
          grafikumgeschalten:=true;
          maussetpos(100,100);
        end;
      end
    end else if not zahlen then begin
      zahlen:=not zahlen;
      if grafikumgeschalten then begin
        graphdriver:=detect;
        initgraph(graphdriver,graphmode,pfad);
        grafikinit2;
        grafikumgeschalten:=false;
        mausminmaxx(5,maxx-5);
        mausminmaxy(5,maxy);
        maussetpos(100,100);
      end;
      bildneu;
      mausunsicht;
    end;
    if (tasten<>0) then begin
      if kombiniert then begin
        s2:=s2+(integer(100-ypos))/1000;
        zeiger(s2,x2);
        s1:=s1+(integer(xpos-100))/1000;
        zeiger(s1,x1);
      end else begin
        if erstes then begin
          s1:=s1+(integer(xpos-100)+integer(100-ypos))/1000;
          zeiger(s1,x1);
        end else begin
          s2:=s2+(integer(xpos-100)+integer(100-ypos))/1000;
          zeiger(s2,x2);
        end;
      end;
      if zahlen then zeigen(global) else begin
        z:=0;
        za:=lizoom*aspektratio;
        if (graphdriver=ega) or (graphdriver=hercmono) then begin
          setvisualpage(byte(seite));
          seite:=not seite;
          setactivepage(byte(seite));
        end;
        clearviewport;
        repeat
          calc_new_point;
          xh:=(x+relx)*maxx*za;
          yh:=(y+rely)*maxy*lizoom;
          if (abs(xh)>2E9) or (abs(yh)>2E9) then zuruecksetzen;
          putpixel(round(xh),maxy-round(yh),white);
          maustastpos(tasten,xpos,ypos);
          if z<101 then inc(z);
          if ((z>100) and ((graphdriver=ega) or (graphdriver=hercmono))) then
            setvisualpage(byte(seite));
        until ((xpos<>100) or (ypos<>100) or (tasten<3)) and (z>100);
      end;
    end;
  until (tasten=0) and zahlen;
  maussetpos(xalt,yalt);
  maussicht;
end;

procedure setzufall(hilf:integer);
begin
  if (hilf>=0) and (hilf<=255) and (hilf<(zufallgesamt+hilf-akttrans^.zufall)) then begin
    inc(zufallgesamt,hilf-akttrans^.zufall);
    akttrans^.zufall:=hilf;
    mausunsicht;
    zeigeb(akttrans^.zufall,8*73,maxy-20);
    if zufallgesamt<>0 then zeigeb(trunc(akttrans^.zufall/zufallgesamt*100),8*73,maxy-10) else
    zeigeb(0,8*73,maxy-10);
  end;
end;

procedure getzufall;
var xalt,yalt:word;
    schirm:boolean;
    z:byte;
begin
  schirm:=true;
  maustastpos(tasten,xpos,ypos);
  xalt:=xpos;yalt:=ypos;
  mausunsicht;
  repeat
    maussetpos(100,100);
    repeat
      maustastpos(tasten,xpos,ypos);
      if tasten>1 then begin
        if schirm then begin
          schirm:=false;
          clearviewport;
          randomize;
          x:=random;
          y:=random;
          for z:=0 to 100 do calc_new_point;
          za:=lizoom*aspektratio;
        end;
        calc_new_point;
        xh:=(x+relx)*maxx*za;
        yh:=(y+rely)*maxy*lizoom;
        if (abs(xh)>2E9) or (abs(yh)>2E9) then zuruecksetzen;
        putpixel(round(xh),maxy-round(yh),white);
      end;
    until (tasten=0) or (xpos<>100) or (ypos<>100);
    if tasten<>0 then setzufall(round((integer(xpos-100)+integer(100-ypos))/5)+akttrans^.zufall);
  until (tasten=0);
  if not schirm then bildneu;
  maussetpos(xalt,yalt);
  maussicht;
end;

procedure getzahl(var zahl:real;x:word;global:byte);
var text:string[6];
    hilf:real;
    code:integer;
begin
  hilf:=zahl;
  setcolor(brown);
  mausunsicht;
  bar(x,maxy-20,x+6*8,maxy-11);
  getstring(text,x,maxy-20,6);
  val(text,zahl,code);
  if code<>0 then zahl:=hilf;
  mausunsicht;
  bar(x,maxy-20,x+6*8,maxy-11);
  zeiger(zahl,x);
  zeigen(global);
  maussicht;
end;

procedure transnormal;
begin
  mausunsicht;
  if akttrans^.zurueck=nil then setcolor(white) else setcolor(yellow);
  showtrans(akttrans^,aspektratio,relx,rely,zoom,rechteck);
  if akttrans^.zurueck=nil then setcolor(lightblue) else setcolor(green);
  showtrans(akttrans^,aspektratio,relx,rely,zoom,rechteck);
  maussicht;
end;

procedure transzeigen;
begin
  mausunsicht;
  if akttrans^.zurueck=nil then setcolor(lightblue) else setcolor(green);
  showtrans(akttrans^,aspektratio,relx,rely,zoom,rechteck);
  if akttrans^.zurueck=nil then setcolor(white) else setcolor(yellow);
  showtrans(akttrans^,aspektratio,relx,rely,zoom,rechteck);
  update_hilftrans;
  maussicht;
end;

procedure neuetrans;
begin
  if (trans=nil) or (akttrans^.weiter= nil) then begin
    if trans<>nil then transnormal;
    new(akttrans);
    akttrans^.zurueck:=trans;
    if trans<>nil then trans^.weiter:=akttrans;
    trans:=akttrans;
    trans^.weiter:=nil;
    with akttrans^ do begin
      a[1,1]:=1; a[2,1]:=0;
      a[1,2]:=0; a[2,2]:=1;
      if akttrans^.zurueck=nil then begin
        b[1  ]:=-0.5; b[2  ]:=-0.5;
      end else begin
        b[1  ]:=0; b[2  ]:=0;
      end;
      if trans^.zurueck=nil then zufall:=0 else begin
        zufall:=1;
        inc(zufallgesamt);
      end;
    end;
    inc(transanzahl);
    inc(akttranszahl);
    mausunsicht;
    werteneu;
    if trans^.zurueck=nil then begin
      setcolor(white);
      berechnerechteck;
    end else setcolor(yellow);
    showtrans(akttrans^,aspektratio,relx,rely,zoom,rechteck);
    update_hilftrans;
    maussicht;
  end else begin
    transnormal;
    akttrans:=akttrans^.weiter;
    transzeigen;
    inc(akttranszahl);
    werteneu;
  end;
end;

procedure transzurueck;
begin
  if akttrans^.zurueck<>nil then begin
    transnormal;
    akttrans:=akttrans^.zurueck;
    transzeigen;
    dec(akttranszahl);
  end;
  werteneu;
end;

procedure loesche;
var htrans:transzeiger;
begin
  if akttrans^.zurueck=nil then exit; {t0 darf nicht gelscht werden}
  htrans:=akttrans;
  if htrans^.zurueck<>nil then begin
    htrans:=htrans^.zurueck;
    dec(akttranszahl);
  end else if htrans^.weiter<>nil then htrans:=htrans^.weiter else exit;
  dec(transanzahl);
  mausunsicht;
  setcolor(yellow);
  showtrans(akttrans^,aspektratio,relx,rely,zoom,rechteck);
  maussicht;
  if akttrans^.weiter<>nil then akttrans^.weiter^.zurueck:=akttrans^.zurueck;
  if akttrans^.zurueck<>nil then akttrans^.zurueck^.weiter:=akttrans^.weiter;
  if trans=akttrans then trans:=htrans;
  dec(zufallgesamt,akttrans^.zufall);
  dispose(akttrans);
  akttrans:=htrans;
  transzeigen;
  werteneu;
end;

procedure save;
var fractdatei:file;
    hilftrans:transzeiger;
    hilffract:fractsavetyp;
begin
  assign(fractdatei,name+'.FRA');
  rewrite(fractdatei,1);
  blockwrite(fractdatei,relx,sizeof(relx));
  blockwrite(fractdatei,rely,sizeof(rely));
  blockwrite(fractdatei,zoom,sizeof(zoom));
  blockwrite(fractdatei,lizoom,sizeof(lizoom));
  hilftrans:=trans;
  while hilftrans^.zurueck<>nil do hilftrans:=hilftrans^.zurueck;
  while hilftrans<>nil do begin
    hilffract.a:=hilftrans^.a;
    hilffract.b:=hilftrans^.b;
    hilffract.zufall:=hilftrans^.zufall;
    blockwrite(fractdatei,hilffract,sizeof(hilffract));
    hilftrans:=hilftrans^.weiter;
  end;
  close(fractdatei);
end;

procedure saveifs;
var hilftrans:transzeiger;
    hilffract:fractsavetyp;
    ifs:text;

function stri(x:real):string;
var hilf:string;
begin
  str(x:4:2,hilf);
  stri:=hilf;
end;

begin
  assign(ifs,name+'.IFS');
  rewrite(ifs);
  hilftrans:=trans;
  while hilftrans^.zurueck<>nil do hilftrans:=hilftrans^.zurueck;
  hilftrans:=hilftrans^.weiter;
  while hilftrans<>nil do begin
     writeln(ifs,stri(hilftrans^.a[1,1]):6,stri(hilftrans^.a[1,2]):6,
                 stri(hilftrans^.a[2,1]):6,stri(hilftrans^.a[2,2]):6,
                 stri(hilftrans^.b[1]  ):6,stri(hilftrans^.b[2]  ):6,
                 stri(hilftrans^.zufall/zufallgesamt):6);
    hilftrans:=hilftrans^.weiter;
  end;
  close(ifs);
end;

procedure load;
var fractdatei:file;
    hilffract:fractsavetyp;
    suche:searchrec;
begin
  findfirst(name+'.fra',$3f,suche);
  if doserror<>0 then exit;
  akttrans:=trans;
  while akttrans<>nil do begin
    akttrans:=akttrans^.zurueck;
    dispose(trans);
    trans:=akttrans;
  end;
  transanzahl:=0;
  zufallgesamt:=0;
  assign(fractdatei,name+'.FRA');
  reset(fractdatei,1);
  blockread(fractdatei,relx,sizeof(relx));
  blockread(fractdatei,rely,sizeof(rely));
  blockread(fractdatei,zoom,sizeof(zoom));
  blockread(fractdatei,lizoom,sizeof(lizoom));
  while not eof(fractdatei) do begin
    new(akttrans);
    akttrans^.zurueck:=trans;
    akttrans^.weiter:=nil;
    if trans<>nil then trans^.weiter:=akttrans;
    trans:=akttrans;
    blockread(fractdatei,hilffract,sizeof(hilffract));
    akttrans^.a:=hilffract.a;
    akttrans^.b:=hilffract.b;
    akttrans^.zufall:=hilffract.zufall;
    inc(zufallgesamt,hilffract.zufall);
    if transanzahl=0 then berechnerechteck;
    inc(transanzahl);
  end;
  dec(transanzahl);
  akttranszahl:=transanzahl;
  close(fractdatei);
end;

procedure zeichnefraktal;
var za:real;
    z:byte;
begin
  clearviewport;
  randomize;
  x:=random;
  y:=random;
  for z:=0 to 100 do calc_new_point;
  za:=lizoom*aspektratio;
  if (graphdriver=cga) or (graphdriver=hercmono) then
  repeat
    calc_new_point;
    xh:=(x+relx)*maxx*za;
    yh:=(y+rely)*maxy*lizoom;
    if (abs(xh)>2E9) or (abs(yh)>2E9) then zuruecksetzen;
    putpixel(round(xh),maxy-round(yh),white);
  until keypressed or (mauspresent and mauskeypressed) else
  repeat
    calc_new_point;
    xh:=(x+relx)*maxx*za;
    yh:=(y+rely)*maxy*lizoom;
    if (abs(xh)>2E9) or (abs(yh)>2E9) then zuruecksetzen;
    putpixel(round(xh),maxy-round(yh),lightgreen);
  until keypressed or (mauspresent and mauskeypressed);
  bildneu;
  while keypressed do ein:=readkey;
end;

procedure version;
begin
  mausunsicht;
  setcolor(green);
  outtextxy(10,10,'L I M E S   Fraktale');
  outtextxy(50,30,'Version 1.0');
  outtextxy(10,50,'Florian Schreck 1990');
  if mauspresent then maustastpos(tasten,altx,alty) else begin
    xpos:=altx;ypos:=alty;
  end;
  repeat
    if mauspresent then maustastpos(tasten,xpos,ypos);
  until (xpos<>altx) or (ypos<>alty) or (tasten<>0) or keypressed;
  bar(10,10,180,60);
  maussicht;
end;

procedure grafikinit;
var error:integer;
begin
  if (registerbgidriver(@EGAVGAdriver)<0) or (registerbgidriver(@HERCdriver)<0)
     or (registerbgidriver(@CGAdriver)<0) then begin
     writeln('Fehler beim Anmelden der Grafiktreiber!',^G);
     halt(1);
  end;
  pfad:='';
  repeat
    graphdriver:=detect;
    initgraph(graphdriver,graphmode,pfad);
    error:=graphresult;
    if error<>0 then begin
      writeln(grapherrormsg(error));
      write(^G,'Geben Sie Ihren Grafik Pfad ein : ');
      readln(pfad);
      if pfad='' then halt(1);
    end;
  until error=0;
  grafikinit2;
end;

procedure dir;
type eintragstr=string[12];
     eintragzeiger=^eintragtyp;
     eintragtyp=record
                  weiter,zurueck:eintragzeiger;
                  name:eintragstr;
                  typ:byte;
                  size:word;
                end;
var suche:searchrec;
    akt,x:shortint;
    xalt,yalt,puffersize:word;
    eintragszahl:byte;
    liste,aktliste,ursprung:eintragzeiger;
    pfad:pathstr;
    puffer,balken:pointer;
    gewechselt,gewahlt,ende:boolean;

procedure neueintrag;
begin
  inc(eintragszahl);
  new(aktliste);
  aktliste^.zurueck:=liste;
  if liste<>nil then liste^.weiter:=aktliste;
  liste:=aktliste;
  liste^.name:=suche.name;
  liste^.typ:=suche.attr;
  liste^.size:=suche.size;
end;

function stri(x:byte):string;
var hilf:string;
begin
  str(x:3,hilf);
  stri:=hilf;
end;

procedure markiere(akt:byte);
begin
  putimage(9+19*8*(pred(akt) mod 4),24+10*(pred(akt) div 4),balken^,xorput);
end;

procedure verschiebe;
begin
  if (akt<1) or (akt>eintragszahl) then akt:=x else begin
    markiere(x);
    markiere(akt);
  end;
end;

function sgn(r:integer):shortint;
begin
  if (r=0) then sgn:=0 else if r>0 then sgn:=1 else sgn:=-1;
end;

begin
  ende:=false;
  xalt:=xpos;yalt:=ypos;
  mausunsicht;
  if (graphdriver=cga) or (graphdriver=hercmono) then setfillstyle(solidfill,white);
  bar(10,10,8*19+10,20);
  getmem(balken,imagesize(10,10,8*19+10,20));
  getimage(10,10,8*19+10,20,balken^);
  if (graphdriver=cga) or (graphdriver=hercmono) then begin
    setfillstyle(solidfill,black);
    bar(10,10,8*19+10,20);
  end;
  repeat
    gewechselt:=false;
    gewahlt:=false;
    eintragszahl:=0;
    liste:=nil;
    findfirst('*.fra',$3f,suche);
    while doserror=0 do begin
      neueintrag;
      findnext(suche);
    end;
    findfirst('*.',directory,suche);
    if suche.name='.' then findnext(suche);
    while doserror=0 do begin
      neueintrag;
      findnext(suche);
    end;
    suche.attr:=0;
    for ein:='A' to 'D' do begin
      suche.name:=ein+':';
      neueintrag;
    end;
    liste^.weiter:=nil;
    while liste^.zurueck<>nil do liste:=liste^.zurueck;
    setfillstyle(solidfill,lightgray);
    setcolor(green);
    setwritemode(copyput);
    x:=30+10*(eintragszahl div 4)+10*byte((eintragszahl mod 4)<>0);
    puffersize:=imagesize(2,2,maxx-4,x+8);
    getmem(puffer,puffersize);
    getimage(2,2,maxx-4,x+8,puffer^);
    bar3d(2,10,maxx-12,x,8,topon);
    setwritemode(xorput);
    if (graphdriver<>cga) and (graphdriver<>hercmono) then setfillstyle(solidfill,blue)
    else setfillstyle(solidfill,black);
    setcolor(black);
    getdir(0,pfad);
    if pfad[length(pfad)]<>'\' then pfad:=pfad+'\';
    outtextxy(8,14,pfad+'*.FRA');
    aktliste:=liste;
    moveto(18,26);
    x:=0;
    while aktliste<>nil do begin
      if x>3 then begin
        moveto(18,10+gety);
        x:=0;
      end;
      if (aktliste^.typ=0) then outtext(aktliste^.name+
          copy('                   ',1,19-length(aktliste^.name)))
      else if (aktliste^.typ and directory)<>0 then outtext(aktliste^.name+
          copy('            ',1,12-length(aktliste^.name))+' <DIR> ')
       else outtext(aktliste^.name+copy('            ',1,12-length(aktliste^.name))+' '+
          stri((aktliste^.size-61) div 37)+'   ');
      inc(x);
      aktliste:=aktliste^.weiter;
    end;
    akt:=1;
    markiere(1);
    if mauspresent then repeat until not mauskeypressed;
    maussetpos(100,100);
    tasten:=0;
    repeat
      repeat
        if mauspresent then maustastpos(tasten,xpos,ypos);
      until keypressed or (tasten<>0) or (abs(integer(xpos)-100)>90) or (abs(integer(ypos)-100)>20);
      if mauspresent then begin
        if abs(integer(xpos)-100)>90 then begin
          x:=akt;
          akt:=akt+sgn(integer(xpos)-100);
          verschiebe;
        end else if abs(integer(ypos)-100)>20 then begin
          x:=akt;
          akt:=akt+4*sgn(integer(ypos)-100);
          verschiebe;
        end;
        gewahlt:=tasten=1;
        ende:=tasten=2;
        maussetpos(100,100);
      end;
      if keypressed then begin
        while keypressed do ein:=upcase(readkey);
        x:=akt;
        case ein of
          #77:begin inc(akt);verschiebe; end;
          #75:begin dec(akt);verschiebe; end;
          #72:begin dec(akt,4);verschiebe; end;
          #80:begin inc(akt,4);verschiebe; end;
          #13:gewahlt:=true;
          #27:ende:=true;
        end;
      end;
    until ende or gewahlt or gewechselt;
    if gewahlt then begin
      aktliste:=liste;
      for x:=2 to akt do aktliste:=aktliste^.weiter;
      if (aktliste^.typ=0) then chdir(aktliste^.name)
      else if ((aktliste^.typ and directory)=0) then begin
        name:=copy(aktliste^.name,1,pred(pos('.',aktliste^.name)));
        load;
        ende:=true;
      end else chdir(aktliste^.name);
    end;
    aktliste:=liste;
    while (aktliste<>nil) do begin
      liste:=aktliste^.weiter;
      dispose(aktliste);
      aktliste:=liste;
    end;
    if not ende then putimage(2,2,puffer^,normalput);
    freemem(puffer,puffersize);
  until ende;
  bildneu;
  freemem(balken,imagesize(0,0,8*19,10));
  maussetpos(xalt,yalt);
end;

procedure getbyte(var zahl:byte;x:word);
var text:string[3];
    hilf:byte;
    code:integer;
begin
  hilf:=zahl;
  setcolor(brown);
  mausunsicht;
  bar(x,maxy-20,x+6*3,maxy-11);
  getstring(text,x,maxy-20,3);
  val(text,zahl,code);
  if code<>0 then zahl:=hilf;
  mausunsicht;
  bar(x,maxy-20,x+6*3,maxy-11);
  zeigeb(zahl,x,maxy-20);
  maussicht;
end;

procedure getzufalltast;
var hilf:byte;
begin
  if (akttranszahl<>0) then begin
    hilf:=akttrans^.zufall;
    getbyte(hilf,8*73);
    setzufall(hilf);
    maussicht;
  end;
end;

{$F+}
procedure ownexit;
begin
  exitproc:=oldexit;
  closegraph;
  while keypressed do ein:=readkey;
  directvideo:=false;
  writeln('Auf Wiedersehen !');
end;
{$F-}

begin
  oldexit:=exitproc;
  exitproc:=@ownexit;
  grafikinit;
  initmauscursor;
  initmaus;
  zoom:=0.45;
  lizoom:=0.45;
  rechteck:=einheitsrechteck;
  relx:=1.5;rely:=1.2;name:='NONAME';
  kombiniert:=true;
  zufallgesamt:=0;
  trans:=nil;
  transanzahl:=0;
  neuetrans;
  transanzahl:=0; {nicht lschen}
  akttranszahl:=0;
  kreuz(aspektratio,relx,rely,zoom);
  maske;
  if paramcount<>0 then begin
    name:=paramstr(1);
    load;
    bildneu;
    if (transanzahl>0) then zeichnefraktal;
  end else version;
  repeat
    if keypressed then begin
      while keypressed do ein:=upcase(readkey);
      with akttrans^ do case ein of
        #27:begin closegraph;halt(0); end;
        'S':save;
        'I':saveifs;
        'L':dir;
        'N':getstring(name,8*46,maxy-10,8);
        'O':loesche;
        #59:getzahl(a[1,1],8,eine);
        #60:getzahl(a[2,2],8*8,eine);
        #61:getzahl(a[1,2],8*15,eine);
        #62:getzahl(a[2,1],8*22,eine);
        #63:getzahl(b[1],8*29,eine);
        #64:getzahl(b[2],8*36,eine);
        #65:getzahl(zoom,8*43,alle);
        #66:getzahl(lizoom,8*50,keine);
        #67:getzahl(relx,8*57,alle);
        #68:getzahl(rely,8*64,alle);
        'Z':getzufalltast;
        #13:if (transanzahl>0) then zeichnefraktal;
        #77:neuetrans;
        #75:transzurueck;
        #72:if (akttranszahl<>0) then begin setzufall(akttrans^.zufall+1);maussicht; end;
        #80:if (akttranszahl<>0) then begin setzufall(akttrans^.zufall-1);maussicht; end;
      end;
    end;
    if mauspresent then begin
      maustastpos(tasten,xpos,ypos);
      if ((xpos<>altx) or (ypos<>alty)) then bewegezeiger;
      mausbenutzt:=true;
      if tasten=1 then with akttrans^ do begin
        if mausin(0   ,maxy-30,8* 7,maxy-11) then getreal(a[1,1],8,a[2,2],8*8,eine,kombiniert,erstes) else
        if mausin(8*8 ,maxy-30,8*14,maxy-11) then getreal(a[1,1],8,a[2,2],8*8,eine,kombiniert,zweites) else
        if mausin(8*15,maxy-30,8*21,maxy-11) then getreal(a[1,2],8*15,a[2,1],8*22,eine,kombiniert,erstes) else
        if mausin(8*22,maxy-30,8*28,maxy-11) then getreal(a[1,2],8*15,a[2,1],8*22,eine,kombiniert,zweites) else
        if mausin(8*29,maxy-30,8*35,maxy-11) then getreal(b[1],8*29,b[2],8*36,eine,kombiniert,erstes) else
        if mausin(8*36,maxy-30,8*42,maxy-11) then getreal(b[1],8*29,b[2],8*36,eine,kombiniert,zweites) else
        if mausin(8*57,maxy-30,8*63,maxy-11) then getreal(relx,8*57,rely,8*64,alle,kombiniert,erstes) else
        if mausin(8*64,maxy-30,8*70,maxy-11) then getreal(relx,8*57,rely,8*64,alle,kombiniert,zweites) else
        if mausin(8*43,maxy-30,8*49,maxy-11) then getreal(zoom,8*43,dummy,0,alle,getrennt,erstes) else
        if mausin(8*50,maxy-30,8*56,maxy-11) then getreal(dummy,0,lizoom,8*50,keine,getrennt,zweites) else
        if mausin(8*72,maxy-30,8*77,maxy-11) and (akttranszahl<>0) then getzufall else
        if mausin(8*60,maxy-10,8*64,maxy) then begin
          closegraph;
          halt(0);
        end else
        if mausin(8*12,maxy-10,8*14,maxy) then neuetrans else
        if mausin(8*5,maxy-10,8*7,maxy) then transzurueck else
        if mausin(8*2,maxy-10,8*3,maxy) then loesche else
        if mausin(8*16,maxy-10,8*18,maxy) and (transanzahl>0) then zeichnefraktal else
        if mausin(8*65,maxy-10,8*68,maxy) then saveifs else
        if mausin(8*30,maxy-10,8*34,maxy) then save else
        if mausin(8*35,maxy-10,8*39,maxy) then dir else
        if mausin(8*40,maxy-10,8*57,maxy) then getstring(name,8*46,maxy-10,8) else
        if mausin(8*20,maxy-10,8*22,maxy) then begin
          kombiniert:=not kombiniert;
          maske;
        end else mausbenutzt:=false;
      end else if (tasten=2) then with akttrans^ do begin
        if mausin(0   ,maxy-30,8* 7,maxy-11) then getzahl(a[1,1],8,eine) else
        if mausin(8*8 ,maxy-30,8*14,maxy-11) then getzahl(a[2,2],8*8,eine) else
        if mausin(8*15,maxy-30,8*21,maxy-11) then getzahl(a[1,2],8*15,eine) else
        if mausin(8*22,maxy-30,8*28,maxy-11) then getzahl(a[2,1],8*22,eine) else
        if mausin(8*29,maxy-30,8*35,maxy-11) then getzahl(b[1],8*29,eine) else
        if mausin(8*36,maxy-30,8*42,maxy-11) then getzahl(b[2],8*36,eine) else
        if mausin(8*57,maxy-30,8*63,maxy-11) then getzahl(relx,8*57,alle) else
        if mausin(8*64,maxy-30,8*70,maxy-11) then getzahl(rely,8*64,alle) else
        if mausin(8*43,maxy-30,8*49,maxy-11) then getzahl(zoom,8*43,alle) else
        if mausin(8*50,maxy-30,8*56,maxy-11) then getzahl(lizoom,8*50,alle) else
        if mausin(8*72,maxy-30,8*77,maxy-11) then getzufalltast
         else mausbenutzt:=false;
      end else mausbenutzt:=false;
      if mausbenutzt then repeat until not mauskeypressed;
    end;
  until false;
end.